from Products.CMFCore.utils import getToolByName
from Products.CMFDefault.Document import addDocument
from Products.CMFPlone.PloneFolder import addPloneFolder
from Products.CMFPlone.PloneUtilities import translate
from AccessControl import getSecurityManager
import Products.CMFPlone.MembershipTool

#from CMFCore.MembershipTool.MembershipTool
def __getPUS(self):
    # Gets something we can call getUsers() and getUserNames() on.
    acl_users = self.acl_users
    if hasattr(acl_users, 'getUsers'):
        return acl_users
    else:
        # This hack works around the absence of getUsers() in LoginManager.
        # Gets the PersistentUserSource object that stores our users
        for us in acl_users.UserSourcesGroup.objectValues():
            if us.meta_type == 'Persistent User Source':
                return us.__of__(acl_users)

#only change is notify wf on creation of folders lines 47 and 104
def pvc_createMemberarea(self, member_id=None):
    """
    Create a member area for 'member_id' or the authenticated user.
    """
    members = self.getMembersFolder()

    if not member_id:
        # member_id is optional (see CMFCore.interfaces.portal_membership:
        #     Create a member area for 'member_id' or authenticated user.)
        portal_membership = getToolByName(self, 'portal_membership')
        member = portal_membership.getAuthenticatedMember()
        member_id = member.getId()

    if hasattr(members, 'aq_explicit'):
        members=members.aq_explicit

    if members is not None and not hasattr(members, member_id):
        wftool = getToolByName( self, 'portal_workflow' )
        f_title = "%s's Home" % member_id
        from Products.CMFPlone.PloneFolder import addPloneFolder
        addPloneFolder(members, id=member_id, title=f_title)
        f=getattr(members, member_id)

        ##############################################################
        #adding the notify created for the workflow piece to work here    
        ##############################################################
        wftool.notifyCreated( f )

        acl_users = __getPUS(self)
        user = acl_users.getUser(member_id)

        if user is not None:
            user= user.__of__(acl_users)
        else:
            from AccessControl import getSecurityManager
            user= getSecurityManager().getUser()
            # check that we do not do something wrong
            if user.getId() != member_id:
                raise NotImplementedError, \
                    'cannot get user for member area creation'

        # Grant Ownership and Owner role to Member
        f.changeOwnership(user)
        f.__ac_local_roles__ = None
        f.manage_setLocalRoles(member_id, ['Owner'])

        # Create Member's home page.
        # Go get the home page text from the skin
        if hasattr(self, 'homePageText'):
            member_object = self.getMemberById(member_id)
            DEFAULT_MEMBER_CONTENT = self.homePageText(member=member_object).strip()
            addDocument( f
                       , 'index_html'
                       , "Home page for " + member_id
                       , ""
                       , "structured-text"
                       , DEFAULT_MEMBER_CONTENT
                       )
            f.index_html._setPortalTypeName( 'Document' )
            # Grant Ownership and Owner role to Member
            f.index_html.changeOwnership(user)
            f.index_html.__ac_local_roles__ = None
            f.index_html.manage_setLocalRoles(member_id, ['Owner'])
            # Overcome an apparent catalog bug.
            f.index_html.reindexObject()
            wftool.notifyCreated( f.index_html )

        #XXX The above was more or less copied from CMFDefault.MembershipTool

        #XXX Below is what really is Plone customizations
        member_folder=self.getHomeFolder(member_id)
        member_folder.description = translate(
            'plone', 'description_member_folder',
            {'member': member_id}, self,
            default = 'Home page area that contains the items created ' \
            'and collected by %s' % member_id)

        member_folder.manage_addPloneFolder(self.personal_id, 'Personal Items')
        personal=getattr(member_folder, self.personal_id)

        ##############################################################
        #adding the notify created for the workflow piece to work here    
        ##############################################################
        wftool.notifyCreated( personal )

        personal.description = "contains personal workarea items for %s" % member_id
        # Grant Ownership and Owner role to Member
        personal.changeOwnership(user)
        personal.__ac_local_roles__ = None
        personal.manage_setLocalRoles(member_id, ['Owner'])
        # Don't add .personal folders to catalog
        catalog = getToolByName(self, 'portal_catalog')
        catalog.unindexObject(personal)

        # Hook to allow doing other things after memberarea creation.
        notify_script = getattr(member_folder, 'notifyMemberAreaCreated', None)

        if notify_script is not None:
            notify_script()


#here is the hot fix
Products.CMFPlone.MembershipTool.MembershipTool.createMemberarea = pvc_createMemberarea