from AccessControl import getSecurityManager
from webdav.WriteLockInterface import WriteLockInterface
from Products.CMFStaging.LockTool import LockingError, pathOf
from OFS.Image import File

import struct
from OFS.content_types import guess_content_type
from Globals import DTMLFile
from OFS.PropertyManager import PropertyManager
from AccessControl.Role import RoleManager
from webdav.common import rfc1123_date
from webdav.Lockable import ResourceLockedError
from webdav.WriteLockInterface import WriteLockInterface
from OFS.SimpleItem import Item_w__name__
from cStringIO import StringIO
from Globals import Persistent
from Acquisition import Implicit
from DateTime import DateTime
from OFS.Cache import Cacheable
from mimetools import choose_boundary
from ZPublisher import HTTPRangeSupport
from ZPublisher.HTTPRequest import FileUpload
from zExceptions import Redirect
from cgi import escape

def locker(self):
    '''Returns the locker of an object'''
    if not WriteLockInterface.isImplementedBy(self):
        raise LockingError, "%s is not lockable" % pathOf(self)
    
    values = self.wl_lockValues()
    if not values:
        return ''

    creator = values[0].getCreator()
    if creator:
        return creator[1]  # The user id without the path
    return ''  # An expired lock?

def isLockedOut(self):
    '''Returns a true value if the current user is locked out.'''
    locker_id = self.locker()
    if locker_id:
        uid = getSecurityManager().getUser().getId()
        if uid != locker_id:
            return 1
    return 0

def failIfLocked(self):
        """
        Check if isLocked via webDav
        """
        if self.wl_isLocked() and self.isLockedOut():
            raise ResourceLockedError, 'This resource is locked via webDAV'
        return 0
    
def upload(self,file='',REQUEST=None):
    """
    Replaces the current contents of the File or Image object with file.

    The file or images contents are replaced with the contents of 'file'.
    """
#    if self.wl_isLocked():
#        raise ResourceLockedError, "File is locked via WebDAV"

    self.failIfLocked()

    data, size = self._read_data(file)
    content_type=self._get_content_type(file, data, self.__name__,
                                        'application/octet-stream')
    self.update_data(data, content_type, size)

    if REQUEST:
        message="Saved changes."
        return self.manage_main(self,REQUEST,manage_tabs_message=message)

File.locker = locker
File.isLockedOut = isLockedOut
File.failIfLocked = failIfLocked
File.manage_upload=upload
