import sys,  Globals, OFS.Moniker, tempfile, ExtensionClass
from marshal import loads, dumps
from urllib import quote, unquote
from zlib import compress, decompress

from App.Dialogs import MessageDialog
from AccessControl import getSecurityManager
from Acquisition import aq_base, aq_inner, aq_parent
from zExceptions import Unauthorized, BadRequest
from webdav.Lockable import ResourceLockedError
from cgi import escape

from Products.CMFCore.PortalContent import PortalContent
from AccessControl import getSecurityManager
from webdav.WriteLockInterface import WriteLockInterface
from Products.CMFStaging.LockTool import LockingError, pathOf
from OFS.CopySupport import *
from OFS.Image import *


def locker(self):
    '''Returns the locker of an object'''
    if not WriteLockInterface.isImplementedBy(self):
        raise LockingError, "%s is not lockable" % pathOf(self)
    
    values = self.wl_lockValues()
    if not values:
        return ''

    creator = values[0].getCreator()
    if creator:
        return creator[1]  # The user id without the path
    return ''  # An expired lock?

def isLockedOut(self):
    '''Returns a true value if the current user is locked out.'''
    locker_id = self.locker()
    if locker_id:
        uid = getSecurityManager().getUser().getId()
        if uid != locker_id:
            return 1
    return 0

def failIfLocked(self):
        """
        Check if isLocked via webDav
        """
        if self.wl_isLocked() and self.isLockedOut():
            raise ResourceLockedError, 'This resource is locked via webDAV'
        return 0
    
def renameObject(self, id, new_id, REQUEST=None):
    """Rename a particular sub-object"""
    try: self._checkId(new_id)
    except: raise CopyError, MessageDialog(
                  title='Invalid Id',
                  message=sys.exc_info()[1],
                  action ='manage_main')
    ob=self._getOb(id)

#    if ob.wl_isLocked():
#        raise ResourceLockedError, 'Object "%s" is locked via WebDAV' % ob.getId()
    if not ob.cb_isMoveable():
        raise CopyError, eNotSupported % escape(id)
    self._verifyObjectPaste(ob)
    try:    ob._notifyOfCopyTo(self, op=1)
    except: raise CopyError, MessageDialog(
                  title='Rename Error',
                  message=sys.exc_info()[1],
                  action ='manage_main')
    self._delObject(id)
    ob = aq_base(ob)
    ob._setId(new_id)

    # Note - because a rename always keeps the same context, we
    # can just leave the ownership info unchanged.
    self._setObject(new_id, ob, set_owner=0)

    if REQUEST is not None:
        return self.manage_main(self, REQUEST, update_menu=1)
    return None

def manage_upload(self,file='',REQUEST=None):
    """
    Replaces the current contents of the File or Image object with file.

    The file or images contents are replaced with the contents of 'file'.
    """
    if self.wl_isLocked():
        raise ResourceLockedError, "File is locked via WebDAV"

    data, size = self._read_data(file)
    content_type=self._get_content_type(file, data, self.__name__,
                                        'application/octet-stream')
    self.update_data(data, content_type, size)

    if REQUEST:
        message="Saved changes."
        return self.manage_main(self,REQUEST,manage_tabs_message=message)


CopyContainer.manage_renameObject=renameObject

PortalContent.locker = locker
PortalContent.isLockedOut = isLockedOut
PortalContent.failIfLocked = failIfLocked