from Products.CMFStaging.VersionsTool import VersionsTool as BaseTool
from AccessControl import ClassSecurityInfo
from Products.CMFStaging.staging_utils import unproxied
from OFS.Image import File

from Globals import InitializeClass

class VersionsTool(BaseTool):
    """ Plone Versions Tool.
    """
    id = 'portal_versions'
    meta_type = 'Plone Versions Tool'

    security = ClassSecurityInfo()

    security.declarePublic('getVersionOfResource')
    def getVersionOfResource(self, obj, version_id):
        """Reverts the object to the given version.

        If make_new_revision, a new revision is created, so that
        the object's state can progress along a new line without
        making the user deal with branches, labels, etc.
        """
        obj = unproxied(obj)
        repo = self._getVersionRepository()
        info = repo.getVersionInfo(obj)
        old_state = None
        old_state = repo.getVersionOfResource( info.history_id, version_id)
        return old_state


InitializeClass(VersionsTool)