"""
Plone-based WorkflowWithRepositoryTool class.

$Id: WorkflowWithRepositoryTool.py,v 1.2 2002/10/29 20:48:41 dreamcatcher Exp $
"""

import Globals
from AccessControl import ClassSecurityInfo
from Products.CMFPlone.WorkflowTool import WorkflowTool
from Products.CMFStaging.WorkflowWithRepositoryTool import WorkflowWithRepositoryTool

# an alias. too long to type :)
wwrt = WorkflowWithRepositoryTool

class WorkflowWithRepositoryTool (WorkflowTool, WorkflowWithRepositoryTool):
    """
    Workflow tool that uses a workflow status repository.

    Depends on portal_versions.
    """

    meta_type = 'Plone Workflow Tool (repository aware)'

    security = ClassSecurityInfo()
    
    # ensure methods come from the right base class
    _getId = wwrt._getId
    _getRepository = wwrt._getRepository

    security.declarePrivate('getHistoryOf')
    getHistoryOf = wwrt.getHistoryOf
    
    security.declarePrivate('setStatusOf')
    setStatusOf = wwrt.setStatusOf
    
Globals.InitializeClass(WorkflowWithRepositoryTool)

